import 'package:dio/dio.dart';
import 'package:get_it/get_it.dart';
import 'package:pigeonholelive_sdk/pigeonholelive_sdk.dart';
import 'package:pigeonholelive_sdk/src/exceptions/unauthorized_exception.dart';
import 'package:pigeonholelive_sdk/src/exceptions/validation_exception.dart';
import 'package:pigeonholelive_sdk/src/filters/pigeonhole_filter.dart';
import 'package:pigeonholelive_sdk/src/models/pigeonhole/pigeonhole.dart';
import 'package:pigeonholelive_sdk/src/service_provider/service_provider_wrapper.dart';
import 'package:test/test.dart';

void main() async {
  var auth = WorkspaceToken(
    token: 'NqjjA6hURKGehSIyY61OatogIaLYj0i8kXLCdA4ykOn7SQH9VJmyP43fv0X8Qiio',
  );

  var pigeonholeLive = PigeonholeLive(
    auth: auth,
    serviceProviders: [
      ServiceProviderWrapper(setupFunc: (getIt) {
        getIt.registerSingleton<Config>(Config(perPage: 10));
      })
    ],
  );

  var list = await pigeonholeLive.pigeonhole.list(
    // filter: PigeonholeFilter(status: [PigeonholeStatus.live]),
  );

  print(list.data?.first);

  try {
    var nextList = await list.nextPage();
    print('next');
    print(nextList.data?.first);
  } on NoNextPageException catch (e) {
    print(e);
    // no next page, ignore
  }

  // await pigeonholeLive.session.nestSession(pigeonholeId: 1, liveSessionId: 1, liveSessionIdsForNest: [5,6,9]);

  // var list = await pigeonholeLive
  //     .session
  //     .list(pigeonholeId: 68248);
  //
  // print(list.data);

  // try {
  //   var created = await PigeonholeLive(
  //       auth: WorkspaceToken(
  //           token:
  //           'NqjjA6hURKGehSIyY61OatogIaLYj0i8kXLCdA4ykOn7SQH9VJmyP43fv0X8Qiio'))
  //       .pigeonhole
  //       .create(pigeonhole: Pigeonhole());
  //
  //   print(created);
  // } on ValidationException catch (e) {
  //   print(e.validationErrors.errors);
  // } on UnauthorizedException catch (e) {
  //   print(e.pigeonholeError.message);
  // }

  // try {
  //   var created = await PigeonholeLive(
  //       auth: WorkspaceToken(
  //           token:
  //           'NqjjA6hURKGehSIyY61OatogIaLYj0i8kXLCdA4ykOn7SQH9VJmyP43fv0X8Qiio'))
  //       .pigeonhole
  //       .update(pigeonhole: Pigeonhole(id:1));
  //
  //   print(created);
  // } on ValidationException catch (e) {
  //   print(e.validationErrors.errors);
  // } on UnauthorizedException catch (e) {
  //   print(e.pigeonholeError.message);
  // }
}

class TestServiceProvider extends ServiceProviderInterface {
  @override
  void setup() {
    getIt.registerSingleton<Config>(Config(perPage: 10));
  }
}
